<!DOCTYPE html>


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>How to make my app an installable python package? &mdash; Bérou 0.1 documentation</title>
    
    <link rel="stylesheet" href="_static/basic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootstrap-3.3.4/css/bootstrap.min.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootstrap-3.3.4/css/bootstrap-theme.min.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootstrap-sphinx.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '0.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/js/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="_static/js/jquery-fix.js"></script>
    <script type="text/javascript" src="_static/bootstrap-3.3.4/js/bootstrap.min.js"></script>
    <script type="text/javascript" src="_static/bootstrap-sphinx.js"></script>
    <link rel="top" title="Bérou 0.1 documentation" href="index.html" />
    <link rel="next" title="Deploy Bérou" href="deployment.html" />
    <link rel="prev" title="How to translate my app ?" href="i18n.html" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">

  </head>
  <body role="document">

  <div id="navbar" class="navbar navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="index.html">
          Bérou</a>
        <span class="navbar-text navbar-version pull-left"><b>0.1</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="index.html">Site <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"><ul class="current">
<li class="toctree-l1"><a class="reference internal" href="tutorial.html">Tutorial</a></li>
<li class="toctree-l1"><a class="reference internal" href="i18n.html">How to translate my app ?</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="">How to make my app an installable python package?</a></li>
<li class="toctree-l1"><a class="reference internal" href="deployment.html">Deploy Bérou</a></li>
</ul>
</ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"><ul>
<li><a class="reference internal" href="#">How to make my app an installable python package?</a><ul>
<li><a class="reference internal" href="#make-your-app-an-installable-python-package">Make your app an installable python package</a></li>
<li><a class="reference internal" href="#install-application">Install application</a></li>
<li><a class="reference internal" href="#uploading-code-to-gitlab">Uploading code to Gitlab</a></li>
</ul>
</li>
</ul>
</ul>
</li>
              
            
            
              
                
  <li>
    <a href="i18n.html" title="Previous Chapter: How to translate my app ?"><span class="glyphicon glyphicon-chevron-left visible-sm"></span><span class="hidden-sm hidden-tablet">&laquo; How to translate...</span>
    </a>
  </li>
  <li>
    <a href="deployment.html" title="Next Chapter: Deploy Bérou"><span class="glyphicon glyphicon-chevron-right visible-sm"></span><span class="hidden-sm hidden-tablet">Deploy Bérou &raquo;</span>
    </a>
  </li>
              
            
            
            
            
              <li class="hidden-sm">
<div id="sourcelink">
  <a href="_sources/git.txt"
     rel="nofollow">Source</a>
</div></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
    <div class="col-md-12">
      
  <div class="section" id="how-to-make-my-app-an-installable-python-package">
<h1>How to make my app an installable python package?<a class="headerlink" href="#how-to-make-my-app-an-installable-python-package" title="Permalink to this headline">¶</a></h1>
<p>If you have made a few local commits in your git repo,
and if you want to distribute your app, you are on the right page.</p>
<p>You need to clone Bérou, in a different folder, in order to test your changes,
and to be able to continue developing since the following commands will remove
everything in the repository but your application.</p>
<div class="highlight-python"><div class="highlight"><pre>git clone https://gitlab.com/Pacodastre/Berou.git
cd Berou
</pre></div>
</div>
<p>Then, this command will remove everything from your git repository,
and will just leave your application folder.</p>
<div class="highlight-python"><div class="highlight"><pre># run at root of the repo
# where example is the name of your app
git filter-branch --prune-empty --subdirectory-filter berou/my_app/ master
</pre></div>
</div>
<p>According to the man page, the <cite>&#8211;subdirectory-filter</cite> option:</p>
<blockquote>
<div>Only look at the history which touches the given subdirectory.
The result will contain that directory (and only that) as its project root.
Implies the section called “Remap to ancestor”.</div></blockquote>
<p>In order words, it only keeps the commits that were done in the directory, thus, our app.
The <cite>&#8211;prun-empty</cite> will remove the empty commits, i.e all the commits made in Bérou,
not in your app.</p>
<div class="section" id="make-your-app-an-installable-python-package">
<h2>Make your app an installable python package<a class="headerlink" href="#make-your-app-an-installable-python-package" title="Permalink to this headline">¶</a></h2>
<p>Now, we want to make to create a Python package that we can install
i.e add its path to PYTHONPATH.
This will allow us to import it in python like any other python library.
For more information about the way python imports work, you can find some
information on <a class="reference external" href="https://docs.python.org/2/tutorial/modules.html">the python documentation</a>.</p>
<p>Create a directory, with the same name as your app
(the directory has been removed when filtering the git repo).
When the directory has been created, move all the files to it with git.</p>
<div class="highlight-python"><div class="highlight"><pre>mkdir app_name
git mv *.py templates static templatetags locale migrations app_name
</pre></div>
</div>
<p>Note: if you don&#8217;t have custom templatetags, nor a locale folder, simply remove them from the list.
Git will not move any file if one file doesn&#8217;t exist, unlike bash.</p>
<p>Now, we need to create a setup.py, so we can install it.</p>
<p>Here is a template that you can reuse. Adapt it to your app.</p>
<div class="highlight-python"><div class="highlight"><pre><span class="c">#!/usr/bin/env python</span>
<span class="c"># -*- coding: utf-8 -*-</span>

<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">from</span> <span class="nn">setuptools</span> <span class="kn">import</span> <span class="n">setup</span>

<span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">__file__</span><span class="p">),</span> <span class="s">&#39;README.rst&#39;</span><span class="p">))</span> <span class="k">as</span> <span class="n">readme</span><span class="p">:</span>
    <span class="n">README</span> <span class="o">=</span> <span class="n">readme</span><span class="o">.</span><span class="n">read</span><span class="p">()</span>

<span class="c"># allow setup.py to be run from any path</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">normpath</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">__file__</span><span class="p">),</span> <span class="n">os</span><span class="o">.</span><span class="n">pardir</span><span class="p">)))</span>

<span class="n">setup</span><span class="p">(</span>
    <span class="n">name</span><span class="o">=</span><span class="s">&#39;my_app&#39;</span><span class="p">,</span>
    <span class="n">version</span><span class="o">=</span><span class="s">&#39;0.1&#39;</span><span class="p">,</span>

    <span class="c"># can import im python code with: import my_app</span>
    <span class="n">packages</span><span class="o">=</span><span class="p">[</span><span class="s">&#39;my_app&#39;</span><span class="p">],</span>

    <span class="n">include_package_data</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span>
    <span class="n">license</span><span class="o">=</span><span class="s">&#39;AGPL License&#39;</span><span class="p">,</span>
    <span class="n">description</span><span class="o">=</span><span class="s">&#39;My app does lots of things&#39;</span><span class="p">,</span>
    <span class="n">long_description</span><span class="o">=</span><span class="n">README</span><span class="p">,</span>
    <span class="n">url</span><span class="o">=</span><span class="s">&#39;http://project_url&#39;</span><span class="p">,</span>
    <span class="n">author</span><span class="o">=</span><span class="s">u&#39;Your Name&#39;</span><span class="p">,</span>
    <span class="n">author_email</span><span class="o">=</span><span class="s">&#39;your_email_address@example.com&#39;</span><span class="p">,</span>
    <span class="c"># Adapt if needed</span>
    <span class="n">classifiers</span><span class="o">=</span><span class="p">[</span>
        <span class="s">&#39;Environment :: Web Environment&#39;</span><span class="p">,</span>
        <span class="s">&#39;Framework :: Django&#39;</span><span class="p">,</span>
        <span class="s">&#39;Intended Audience :: Developers&#39;</span><span class="p">,</span>
        <span class="s">&#39;License :: OSI Approved :: AGPL License&#39;</span><span class="p">,</span>  <span class="c"># example license</span>
        <span class="s">&#39;Operating System :: OS Independent&#39;</span><span class="p">,</span>
        <span class="s">&#39;Programming Language :: Python&#39;</span><span class="p">,</span>
        <span class="s">&#39;Programming Language :: Python :: 2.7&#39;</span><span class="p">,</span>
        <span class="s">&#39;Topic :: Internet :: WWW/HTTP&#39;</span><span class="p">,</span>
        <span class="s">&#39;Topic :: Internet :: WWW/HTTP :: Dynamic Content&#39;</span><span class="p">,</span>
    <span class="p">],</span>
<span class="p">)</span>
</pre></div>
</div>
<p>In addition to the setup.py, we also need a couple of more files.
The first one to create is the README file that is specified in the setup.py.</p>
<p>Create a README.rst, and write a few lines to describe your project.</p>
<p>After that, you&#8217;ll need two extra files: MANIFEST.in and LICENSE.</p>
<p>in MANIFEST.in:</p>
<div class="highlight-python"><div class="highlight"><pre>include LICENSE
include README.rst
recursive-include erika/static *
recursive-include erika/templates *
recursive-include docs *
</pre></div>
</div>
<p>In LICENSE, include the content of your license.</p>
<p>Your application is ready to be installed.</p>
</div>
<div class="section" id="install-application">
<h2>Install application<a class="headerlink" href="#install-application" title="Permalink to this headline">¶</a></h2>
<p>Make sure your virtual environment is still activated,
and run the following command:</p>
<div class="highlight-python"><div class="highlight"><pre>python setup.py develop
</pre></div>
</div>
<p>This added your app to the PYTHONPATH,
making it possible to import in the virtualenv python.
Django will be able to import your app when loading it at startup.</p>
<p>You can now remove your app from the Bérou project.
If you&#8217;re not sure, don&#8217;t remove your app,
move it to a Bérou root folder.</p>
<p>Run the server, and see if it is Bérou still runs.</p>
</div>
<div class="section" id="uploading-code-to-gitlab">
<h2>Uploading code to Gitlab<a class="headerlink" href="#uploading-code-to-gitlab" title="Permalink to this headline">¶</a></h2>
<p>Create an account on gitlab.com (if you don&#8217;t have one)
and create a project for your application.</p>
<p>Gitlab will give you a url for your repository.</p>
<p>TODO: Include screenshot
You will need to change the remote repository,
and then you can push to Gitlab.</p>
<div class="highlight-python"><div class="highlight"><pre>git remote origin set-url your_git_repo
git push
</pre></div>
</div>
<p>You now should have your app available in gitlab.</p>
</div>
</div>


    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2015, Francois Ribemont.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.3.1.<br/>
    </p>
  </div>
</footer>
  </body>
</html>